'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hammerjs = require('hammerjs');

var _hammerjs2 = _interopRequireDefault(_hammerjs);

var _arrow = require('./svg/arrow');

var _arrow2 = _interopRequireDefault(_arrow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Arrows = function (_React$Component) {
    _inherits(Arrows, _React$Component);

    function Arrows() {
        _classCallCheck(this, Arrows);

        return _possibleConstructorReturn(this, (Arrows.__proto__ || Object.getPrototypeOf(Arrows)).apply(this, arguments));
    }

    _createClass(Arrows, [{
        key: 'render',
        value: function () {
            function render() {
                var wrapper = {
                    position: 'absolute',
                    bottom: '0',
                    width: '100%',
                    height: '100%'
                };

                return _react2['default'].createElement(
                    'div',
                    { style: _extends({}, wrapper, this.props.styles.wrapper), ref: 'hammer' },
                    _react2['default'].createElement(
                        'div',
                        { className: 'slider-arrow left', onClick: this.props.slide.bind(this, 'left') },
                        _react2['default'].createElement(_arrow2['default'], { icon: "left-" + this.props.arrowType, color: this.props.arrowColor, size: this.props.arrowSize })
                    ),
                    _react2['default'].createElement(
                        'div',
                        { className: 'slider-arrow right', onClick: this.props.slide.bind(this, 'right') },
                        _react2['default'].createElement(_arrow2['default'], { icon: "right-" + this.props.arrowType, color: this.props.arrowColor, size: this.props.arrowSize })
                    )
                );
            }

            return render;
        }()
    }, {
        key: 'componentDidMount',
        value: function () {
            function componentDidMount() {
                var _this2 = this;

                if (this.refs.hammer) {
                    (function () {
                        var state = _this2;
                        var hammertime = new _hammerjs2['default'](_this2.refs.hammer);
                        hammertime.on('swipeleft', function () {
                            state.props.slide('right');
                        });
                        hammertime.on('swiperight', function () {
                            state.props.slide('left');
                        });
                    })();
                }
            }

            return componentDidMount;
        }()
    }]);

    return Arrows;
}(_react2['default'].Component);

Arrows.propTypes = {
    slide: _react2['default'].PropTypes.func.isRequired,
    arrowSize: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.number]),
    arrowColor: _react2['default'].PropTypes.string,
    arrowType: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.number]),
    styles: _react2['default'].PropTypes.object
};

Arrows.defaultProps = {
    arrowSize: 30,
    arrowColor: "black",
    arrowType: 1
};

exports['default'] = Arrows;
//# sourceMappingURL=arrows.js.map