'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsCssTransitionGroup = require('react-addons-css-transition-group');

var _reactAddonsCssTransitionGroup2 = _interopRequireDefault(_reactAddonsCssTransitionGroup);

var _remarkable = require('remarkable');

var _remarkable2 = _interopRequireDefault(_remarkable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Block = function (_React$Component) {
    _inherits(Block, _React$Component);

    function Block() {
        _classCallCheck(this, Block);

        return _possibleConstructorReturn(this, (Block.__proto__ || Object.getPrototypeOf(Block)).apply(this, arguments));
    }

    _createClass(Block, [{
        key: 'animation',
        value: function () {
            function animation(trigger, direction) {
                var el = this.refs.block;
                if (el) {
                    el.className = trigger + '-' + direction;
                }
            }

            return animation;
        }()
    }, {
        key: 'render',
        value: function () {
            function render() {
                var _props = this.props,
                    block = _props.block,
                    animationTimeout = _props.animationTimeout;

                var styles = {
                    block: {
                        width: '100%'
                    },
                    author: {}
                };

                var rawMarkup = function () {
                    function rawMarkup(text) {
                        var md = new _remarkable2['default']({ html: true });
                        return { __html: md.render(text) };
                    }

                    return rawMarkup;
                }();

                return _react2['default'].createElement(
                    _reactAddonsCssTransitionGroup2['default'],
                    {
                        transitionName: 'slider-animation',
                        transitionEnterTimeout: animationTimeout,
                        transitionLeaveTimeout: animationTimeout
                    },
                    this.props.current === this.props.block._id ? _react2['default'].createElement(
                        'div',
                        { key: block._id, ref: 'block', style: _extends({}, styles.block, this.props.styles.block) },
                        _react2['default'].createElement(
                            'h3',
                            { style: _extends({}, styles.title, this.props.styles.title) },
                            block.title
                        ),
                        _react2['default'].createElement('div', { dangerouslySetInnerHTML: rawMarkup(block.text) }),
                        _react2['default'].createElement(
                            'p',
                            { style: _extends({}, styles.author, this.props.styles.author) },
                            block.author
                        )
                    ) : ''
                );
            }

            return render;
        }()
    }, {
        key: 'shouldComponentUpdate',
        value: function () {
            function shouldComponentUpdate(nextProps) {
                return this.props.styles !== nextProps.styles || this.props.current !== nextProps.current;
            }

            return shouldComponentUpdate;
        }()
    }, {
        key: 'componentWillUpdate',
        value: function () {
            function componentWillUpdate(nextProps, nextState) {
                if (this.props.current !== nextProps.current) {
                    this.animation('leave', nextProps.direction);
                }
            }

            return componentWillUpdate;
        }()
    }]);

    return Block;
}(_react2['default'].Component);

Block.propTypes = {
    block: _react2['default'].PropTypes.object.isRequired,
    current: _react2['default'].PropTypes.string.isRequired,
    direction: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.bool]),
    animationTimeout: _react2['default'].PropTypes.number.isRequired,
    styles: _react2['default'].PropTypes.object.isRequired
};

exports['default'] = Block;
//# sourceMappingURL=block.js.map