'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _block = require('./block');

var _block2 = _interopRequireDefault(_block);

var _buttons = require('./buttons');

var _buttons2 = _interopRequireDefault(_buttons);

var _arrows = require('./arrows');

var _arrows2 = _interopRequireDefault(_arrows);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextSlider = function (_React$Component) {
    _inherits(TextSlider, _React$Component);

    function TextSlider(props) {
        _classCallCheck(this, TextSlider);

        var _this = _possibleConstructorReturn(this, (TextSlider.__proto__ || Object.getPrototypeOf(TextSlider)).call(this, props));

        _this.setCurrent = _this.setCurrent.bind(_this);
        _this.slide = _this.slide.bind(_this);
        _this.state = {
            current: _this.props.textBlocks ? "0" : false,
            direction: 'right',
            blocks: {}
        };
        return _this;
    }

    _createClass(TextSlider, [{
        key: 'ids',
        value: function () {
            function ids() {
                var array = [];
                this.state.blocks.map(function (block) {
                    array.push(block._id);
                });
                return array;
            }

            return ids;
        }()
    }, {
        key: 'setCurrent',
        value: function () {
            function setCurrent(id, direction) {
                var _this2 = this;

                if (this.unblock !== false) {
                    (function () {
                        var state = _this2;
                        _this2.setState({ current: id, direction: direction });
                        _this2.unblock = false;
                        setTimeout(function () {
                            state.unblock = true;
                        }, _this2.props.animationTimeout);
                    })();
                }
            }

            return setCurrent;
        }()
    }, {
        key: 'slide',
        value: function () {
            function slide(direction) {
                var array = this.ids();
                var current = array.indexOf(this.state.current);
                var max = array.length - 1;
                var next = void 0;

                if (direction === 'left') {
                    next = current - 1;
                    direction = 'right';
                } else if (direction === 'right') {
                    next = current + 1;
                    direction = 'left';
                }

                if (next < 0) next = max;else if (next > max) next = 0;

                return this.setCurrent(array[next], direction);
            }

            return slide;
        }()
    }, {
        key: 'render',
        value: function () {
            function render() {
                var _this3 = this;

                var styles = {
                    wrapper: {
                        width: '100%',
                        position: 'relative',
                        WebkitUserSelect: 'none',
                        MozUserSelect: 'none',
                        MsSelect: 'none',
                        UserSelect: 'none',
                        paddingBottom: '50px',
                        textAlign: 'center'
                    }
                };

                if (this.state.blocks.length > 0) {
                    return _react2['default'].createElement(
                        'div',
                        { style: Object.assign({}, styles.wrapper, this.props.styles.wrapper) },
                        this.state.blocks.map(function (block) {
                            return _react2['default'].createElement(_block2['default'], {
                                key: block._id,
                                block: block,
                                current: _this3.state.current,
                                direction: _this3.state.direction,
                                animationTimeout: _this3.props.animationTimeout,
                                styles: _this3.props.styles.block ? _this3.props.styles.block : {}
                            });
                        }),
                        this.state.blocks.length > 1 ? _react2['default'].createElement(_arrows2['default'], { slide: this.slide,
                            styles: this.props.styles.arrows ? this.props.styles.arrows : {},
                            arrowSize: this.props.arrowSize,
                            arrowColor: this.props.arrowColor,
                            arrowType: this.props.arrowType
                        }) : '',
                        this.state.blocks.length > 1 ? _react2['default'].createElement(_buttons2['default'], { ids: this.ids(),
                            setCurrent: this.setCurrent,
                            current: this.state.current,
                            styles: this.props.styles.buttons ? this.props.styles.buttons : {}
                        }) : ''
                    );
                } else {
                    return _react2['default'].createElement(
                        'div',
                        { className: 'loading-msg' },
                        'Loading slider...'
                    );
                }
            }

            return render;
        }()
    }, {
        key: 'initBlocks',
        value: function () {
            function initBlocks() {
                var textBlocks = this.props.textBlocks;

                for (var i in textBlocks) {
                    if (!textBlocks[i].hasOwnProperty('_id')) {
                        textBlocks[i]._id = String(i);
                    }
                }
                this.setState({ blocks: textBlocks });
            }

            return initBlocks;
        }()
    }, {
        key: 'componentWillMount',
        value: function () {
            function componentWillMount() {
                this.initBlocks();
            }

            return componentWillMount;
        }()
    }, {
        key: 'shouldComponentUpdate',
        value: function () {
            function shouldComponentUpdate(nextProps, nextState) {
                return nextProps.textBlocks !== this.props.textBlocks || nextProps.styles !== this.props.styles || nextState.current !== this.state.current || nextState.direction !== this.state.direction || nextState.blocks !== this.state.blocks;
            }

            return shouldComponentUpdate;
        }()
    }]);

    return TextSlider;
}(_react2['default'].Component);

TextSlider.propTypes = {
    textBlocks: _react2['default'].PropTypes.array.isRequired,
    animationTimeout: _react2['default'].PropTypes.number,
    styles: _react2['default'].PropTypes.object,
    arrowSize: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.number]),
    arrowColor: _react2['default'].PropTypes.string,
    arrowType: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.number])
};

TextSlider.defaultProps = {
    animationTimeout: 300,
    styles: {}
};

exports['default'] = TextSlider;
//# sourceMappingURL=text-slider.js.map